<html>
<head>
<title>OgreResource.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreResource.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreResource_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _Resource_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _Resource_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreSharedPtr_8h.html">OgreSharedPtr.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreStringInterface_8h.html">OgreStringInterface.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreAtomicWrappers_8h.html">OgreAtomicWrappers.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038 
<a name="l00039"></a><a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">00039</a>     <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a>;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042     <span class="comment">// Forward declaration</span>
<a name="l00043"></a>00043     <span class="keyword">class </span><a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>;
<a name="l00044"></a>00044 
<a name="l00077"></a><a class="code" href="classOgre_1_1Resource.html">00077</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1StringInterface.html" title="Class defining the common interface which classes can use to present a reflection-style, self-defining parameter set to callers.">StringInterface</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ResourceAlloc</a>
<a name="l00078"></a>00078     {
<a name="l00079"></a>00079     <span class="keyword">public</span>:
<a name="l00080"></a>00080         <a class="code" href="OgrePrerequisites_8h.html#a18a523fad1f9e10324e1742865f562b7">OGRE_AUTO_MUTEX</a> <span class="comment">// public to allow external locking</span>
<a name="l00081"></a><a class="code" href="classOgre_1_1Resource_1_1Listener.html">00081</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1Resource_1_1Listener.html">Listener</a>
<a name="l00082"></a>00082         {
<a name="l00083"></a>00083         <span class="keyword">public</span>:
<a name="l00084"></a><a class="code" href="classOgre_1_1Resource_1_1Listener.html#a082340c9150be4d1b0509fd235e26ddc">00084</a>             <a class="code" href="classOgre_1_1Resource_1_1Listener.html#a082340c9150be4d1b0509fd235e26ddc">Listener</a>() {}
<a name="l00085"></a><a class="code" href="classOgre_1_1Resource_1_1Listener.html#a087cbfc9a4ad6490b09884d482932945">00085</a>             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Resource_1_1Listener.html#a087cbfc9a4ad6490b09884d482932945">~Listener</a>() {}
<a name="l00086"></a>00086 
<a name="l00091"></a><a class="code" href="classOgre_1_1Resource_1_1Listener.html#a7e351c772904425efce5e94f0418e6ca">00091</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Resource_1_1Listener.html#a7e351c772904425efce5e94f0418e6ca" title="Callback to indicate that background loading has completed.">backgroundLoadingComplete</a>(<a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>*) {}
<a name="l00092"></a>00092 
<a name="l00097"></a><a class="code" href="classOgre_1_1Resource_1_1Listener.html#abcafaeb14fede970bb6a1f1920dcf2e0">00097</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Resource_1_1Listener.html#abcafaeb14fede970bb6a1f1920dcf2e0" title="Callback to indicate that background preparing has completed.">backgroundPreparingComplete</a>(<a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>*) {}
<a name="l00098"></a>00098 
<a name="l00107"></a><a class="code" href="classOgre_1_1Resource_1_1Listener.html#ac8d962ac52ef53a2ad6ddbdc5b6c9655">00107</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Resource_1_1Listener.html#ac8d962ac52ef53a2ad6ddbdc5b6c9655" title="Called whenever the resource finishes loading.">loadingComplete</a>(<a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>*) {}
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00118"></a><a class="code" href="classOgre_1_1Resource_1_1Listener.html#a7951abdcff85efd6cf58a49d94442f67">00118</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Resource_1_1Listener.html#a7951abdcff85efd6cf58a49d94442f67" title="called whenever the resource finishes preparing (paging into memory).">preparingComplete</a>(<a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>*) {}
<a name="l00119"></a>00119 
<a name="l00121"></a><a class="code" href="classOgre_1_1Resource_1_1Listener.html#a9f8cdeb73a65a6a1c018e5ac783dfafe">00121</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Resource_1_1Listener.html#a9f8cdeb73a65a6a1c018e5ac783dfafe" title="Called whenever the resource has been unloaded.">unloadingComplete</a>(<a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>*) {}
<a name="l00122"></a>00122         };
<a name="l00123"></a>00123         
<a name="l00125"></a><a class="code" href="classOgre_1_1Resource.html#a07e619aa09d3bc6789a6667cb4fc572c">00125</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1Resource.html#a07e619aa09d3bc6789a6667cb4fc572c" title="Enum identifying the loading state of the resource.">LoadingState</a>
<a name="l00126"></a>00126         {
<a name="l00128"></a><a class="code" href="classOgre_1_1Resource.html#a07e619aa09d3bc6789a6667cb4fc572ca28d463296cacdfc115dbc3fb02d00e94">00128</a>             <a class="code" href="classOgre_1_1Resource.html#a07e619aa09d3bc6789a6667cb4fc572ca28d463296cacdfc115dbc3fb02d00e94" title="Not loaded.">LOADSTATE_UNLOADED</a>,
<a name="l00130"></a><a class="code" href="classOgre_1_1Resource.html#a07e619aa09d3bc6789a6667cb4fc572caf138fc9087e0dc755bff08a83720cbb5">00130</a>             <a class="code" href="classOgre_1_1Resource.html#a07e619aa09d3bc6789a6667cb4fc572caf138fc9087e0dc755bff08a83720cbb5" title="Loading is in progress.">LOADSTATE_LOADING</a>,
<a name="l00132"></a><a class="code" href="classOgre_1_1Resource.html#a07e619aa09d3bc6789a6667cb4fc572caa38cbef7605fc4bff6da2f34599ace8f">00132</a>             <a class="code" href="classOgre_1_1Resource.html#a07e619aa09d3bc6789a6667cb4fc572caa38cbef7605fc4bff6da2f34599ace8f" title="Fully loaded.">LOADSTATE_LOADED</a>,
<a name="l00134"></a><a class="code" href="classOgre_1_1Resource.html#a07e619aa09d3bc6789a6667cb4fc572ca4228d390b3a9ed614001db177d1f441e">00134</a>             <a class="code" href="classOgre_1_1Resource.html#a07e619aa09d3bc6789a6667cb4fc572ca4228d390b3a9ed614001db177d1f441e" title="Currently unloading.">LOADSTATE_UNLOADING</a>,
<a name="l00136"></a><a class="code" href="classOgre_1_1Resource.html#a07e619aa09d3bc6789a6667cb4fc572ca133a073b86c346096237063f99870fc1">00136</a>             <a class="code" href="classOgre_1_1Resource.html#a07e619aa09d3bc6789a6667cb4fc572ca133a073b86c346096237063f99870fc1" title="Fully prepared.">LOADSTATE_PREPARED</a>,
<a name="l00138"></a><a class="code" href="classOgre_1_1Resource.html#a07e619aa09d3bc6789a6667cb4fc572cab43c913411f4a96722902f17b88f10fb">00138</a>             LOADSTATE_PREPARING
<a name="l00139"></a>00139         };
<a name="l00140"></a>00140     <span class="keyword">protected</span>:
<a name="l00142"></a><a class="code" href="classOgre_1_1Resource.html#a79c8dbcaa3f5359186352418383e1046">00142</a>         <a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* <a class="code" href="classOgre_1_1Resource.html#a79c8dbcaa3f5359186352418383e1046" title="Creator.">mCreator</a>;
<a name="l00144"></a><a class="code" href="classOgre_1_1Resource.html#a18a3db85a240eda9dfe741a46f2c01c9">00144</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Resource.html#a18a3db85a240eda9dfe741a46f2c01c9" title="Unique name of the resource.">mName</a>;
<a name="l00146"></a><a class="code" href="classOgre_1_1Resource.html#a416b0fb05b6c9f03e11d0d8c4e2cbeea">00146</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Resource.html#a416b0fb05b6c9f03e11d0d8c4e2cbeea" title="The name of the resource group.">mGroup</a>;
<a name="l00148"></a><a class="code" href="classOgre_1_1Resource.html#a269fd910e51c66290e0ffe5c2ac134d3">00148</a>         <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> <a class="code" href="classOgre_1_1Resource.html#a269fd910e51c66290e0ffe5c2ac134d3" title="Numeric handle for more efficient look up than name.">mHandle</a>;
<a name="l00150"></a><a class="code" href="classOgre_1_1Resource.html#a9c01143012af1b51e648f40e0038476a">00150</a>         <a class="code" href="classOgre_1_1AtomicScalar.html">AtomicScalar&lt;LoadingState&gt;</a> <a class="code" href="classOgre_1_1Resource.html#a9c01143012af1b51e648f40e0038476a" title="Is the resource currently loaded?">mLoadingState</a>;
<a name="l00152"></a><a class="code" href="classOgre_1_1Resource.html#a6b9f18275f5f5a4dc3b83f23027a5d78">00152</a>         <span class="keyword">volatile</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Resource.html#a6b9f18275f5f5a4dc3b83f23027a5d78" title="Is this resource going to be background loaded? Only applicable for multithreaded.">mIsBackgroundLoaded</a>;
<a name="l00154"></a><a class="code" href="classOgre_1_1Resource.html#afdef34c49ee7a3b256672e3e4b183142">00154</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Resource.html#afdef34c49ee7a3b256672e3e4b183142" title="The size of the resource in bytes.">mSize</a>;
<a name="l00156"></a><a class="code" href="classOgre_1_1Resource.html#a14dce433a68055e7683aa872c197d1d8">00156</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Resource.html#a14dce433a68055e7683aa872c197d1d8" title="Is this file manually loaded?">mIsManual</a>;
<a name="l00158"></a><a class="code" href="classOgre_1_1Resource.html#a342fcd2c8c95309e12dea3c699f91c15">00158</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Resource.html#a342fcd2c8c95309e12dea3c699f91c15" title="Origin of this resource (e.g. script name) - optional.">mOrigin</a>;
<a name="l00160"></a><a class="code" href="classOgre_1_1Resource.html#a11c91bed31936b5dec39e30d77498470">00160</a>         <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* <a class="code" href="classOgre_1_1Resource.html#a11c91bed31936b5dec39e30d77498470" title="Optional manual loader; if provided, data is loaded from here instead of a file.">mLoader</a>;
<a name="l00162"></a><a class="code" href="classOgre_1_1Resource.html#a3935b76c9f120dab0419734d990eccaa">00162</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Resource.html#a3935b76c9f120dab0419734d990eccaa" title="State count, the number of times this resource has changed state.">mStateCount</a>;
<a name="l00163"></a>00163 
<a name="l00164"></a><a class="code" href="classOgre_1_1Resource.html#a7395c6b8451100dd30e688595b5ff2c6">00164</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1set.html">set&lt;Listener*&gt;::type</a> <a class="code" href="classOgre_1_1Resource.html#a7395c6b8451100dd30e688595b5ff2c6">ListenerList</a>;
<a name="l00165"></a><a class="code" href="classOgre_1_1Resource.html#a94e78b7ae5be758c317ae1e8c4e14f1b">00165</a>         <a class="code" href="classOgre_1_1Resource.html#a7395c6b8451100dd30e688595b5ff2c6">ListenerList</a> <a class="code" href="classOgre_1_1Resource.html#a94e78b7ae5be758c317ae1e8c4e14f1b">mListenerList</a>;
<a name="l00166"></a>00166         <a class="code" href="OgrePrerequisites_8h.html#a2fb96ea8ad9700f804480d1d7f5d692d">OGRE_MUTEX</a>(mListenerListMutex)
<a name="l00167"></a>00167 
<a name="l00168"></a>00168         
<a name="l00170"></a><a class="code" href="classOgre_1_1Resource.html#af16d869fa1c3671447a1e22ae6228242">00170</a>         <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>() 
<a name="l00171"></a>00171             : mCreator(0), mHandle(0), mLoadingState(LOADSTATE_UNLOADED), 
<a name="l00172"></a>00172             mIsBackgroundLoaded(false), mSize(0), mIsManual(0), mLoader(0)
<a name="l00173"></a>00173         { 
<a name="l00174"></a>00174         }
<a name="l00175"></a>00175 
<a name="l00182"></a><a class="code" href="classOgre_1_1Resource.html#ac21645684d207f29513228e061dec765">00182</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Resource.html#ac21645684d207f29513228e061dec765" title="Internal hook to perform actions before the load process, but after the resource has been marked as &#39;...">preLoadImpl</a>(<span class="keywordtype">void</span>) {}
<a name="l00189"></a><a class="code" href="classOgre_1_1Resource.html#a0ac4960f2e4969be70ded84e35c7728d">00189</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Resource.html#a0ac4960f2e4969be70ded84e35c7728d" title="Internal hook to perform actions after the load process, but before the resource has been marked as f...">postLoadImpl</a>(<span class="keywordtype">void</span>) {}
<a name="l00190"></a>00190 
<a name="l00194"></a><a class="code" href="classOgre_1_1Resource.html#a318dc51074007c20d68db9b40c70da08">00194</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Resource.html#a318dc51074007c20d68db9b40c70da08" title="Internal hook to perform actions before the unload process.">preUnloadImpl</a>(<span class="keywordtype">void</span>) {}
<a name="l00199"></a><a class="code" href="classOgre_1_1Resource.html#ab0e94a1f17f20b3e3c6f3cf4a5aa8096">00199</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Resource.html#ab0e94a1f17f20b3e3c6f3cf4a5aa8096" title="Internal hook to perform actions after the unload process, but before the resource has been marked as...">postUnloadImpl</a>(<span class="keywordtype">void</span>) {}
<a name="l00200"></a>00200 
<a name="l00203"></a><a class="code" href="classOgre_1_1Resource.html#a5e8f978cbb908c67a98d16556c8cd0ef">00203</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Resource.html#a5e8f978cbb908c67a98d16556c8cd0ef" title="Internal implementation of the meat of the &#39;prepare&#39; action.">prepareImpl</a>(<span class="keywordtype">void</span>) {}
<a name="l00208"></a><a class="code" href="classOgre_1_1Resource.html#aa550fde0145a3a0ae0329beaf03f23e1">00208</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Resource.html#aa550fde0145a3a0ae0329beaf03f23e1" title="Internal function for undoing the &#39;prepare&#39; action.">unprepareImpl</a>(<span class="keywordtype">void</span>) {}
<a name="l00212"></a>00212         <span class="keyword">virtual</span> <span class="keywordtype">void</span> loadImpl(<span class="keywordtype">void</span>) = 0;
<a name="l00216"></a>00216         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>) = 0;
<a name="l00218"></a>00218         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> calculateSize(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00219"></a>00219 
<a name="l00220"></a>00220     <span class="keyword">public</span>:
<a name="l00235"></a>00235         <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00236"></a>00236             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0);
<a name="l00237"></a>00237 
<a name="l00243"></a>00243         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>();
<a name="l00244"></a>00244 
<a name="l00259"></a>00259         <span class="keyword">virtual</span> <span class="keywordtype">void</span> prepare(<span class="keywordtype">bool</span> backgroundThread = <span class="keyword">false</span>);
<a name="l00260"></a>00260 
<a name="l00271"></a>00271         <span class="keyword">virtual</span> <span class="keywordtype">void</span> load(<span class="keywordtype">bool</span> backgroundThread = <span class="keyword">false</span>);
<a name="l00272"></a>00272 
<a name="l00278"></a>00278         <span class="keyword">virtual</span> <span class="keywordtype">void</span> reload(<span class="keywordtype">void</span>);
<a name="l00279"></a>00279 
<a name="l00282"></a><a class="code" href="classOgre_1_1Resource.html#aadcc4a98a8450506e6b55800db72d414">00282</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isReloadable(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00283"></a>00283 <span class="keyword">        </span>{
<a name="l00284"></a>00284             <span class="keywordflow">return</span> !mIsManual || mLoader;
<a name="l00285"></a>00285         }
<a name="l00286"></a>00286 
<a name="l00289"></a><a class="code" href="classOgre_1_1Resource.html#afa5615006905ffb68d6e52449306565f">00289</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isManuallyLoaded(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00290"></a>00290 <span class="keyword">        </span>{
<a name="l00291"></a>00291             <span class="keywordflow">return</span> mIsManual;
<a name="l00292"></a>00292         }
<a name="l00293"></a>00293 
<a name="l00297"></a>00297         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unload(<span class="keywordtype">void</span>);
<a name="l00298"></a>00298 
<a name="l00301"></a><a class="code" href="classOgre_1_1Resource.html#aa8e96b7bb387708db2161f7f982407c6">00301</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getSize(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00302"></a>00302 <span class="keyword">        </span>{ 
<a name="l00303"></a>00303             <span class="keywordflow">return</span> mSize; 
<a name="l00304"></a>00304         }
<a name="l00305"></a>00305 
<a name="l00308"></a>00308         <span class="keyword">virtual</span> <span class="keywordtype">void</span> touch(<span class="keywordtype">void</span>);
<a name="l00309"></a>00309 
<a name="l00312"></a><a class="code" href="classOgre_1_1Resource.html#a77fac58a5756d746b2452933f615c25d">00312</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName(<span class="keywordtype">void</span>)<span class="keyword"> const </span>
<a name="l00313"></a>00313 <span class="keyword">        </span>{ 
<a name="l00314"></a>00314             <span class="keywordflow">return</span> mName; 
<a name="l00315"></a>00315         }
<a name="l00316"></a>00316 
<a name="l00317"></a><a class="code" href="classOgre_1_1Resource.html#ae3be647e47679266df79b565ffbe1de7">00317</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> getHandle(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00318"></a>00318 <span class="keyword">        </span>{
<a name="l00319"></a>00319             <span class="keywordflow">return</span> mHandle;
<a name="l00320"></a>00320         }
<a name="l00321"></a>00321 
<a name="l00324"></a><a class="code" href="classOgre_1_1Resource.html#aab3672d493ff4ef995520daf6f5067f0">00324</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isPrepared(<span class="keywordtype">void</span>)<span class="keyword"> const </span>
<a name="l00325"></a>00325 <span class="keyword">        </span>{ 
<a name="l00326"></a>00326             <span class="comment">// No lock required to read this state since no modify</span>
<a name="l00327"></a>00327             <span class="keywordflow">return</span> (mLoadingState.get() == LOADSTATE_PREPARED); 
<a name="l00328"></a>00328         }
<a name="l00329"></a>00329 
<a name="l00332"></a><a class="code" href="classOgre_1_1Resource.html#a10bba19766b989cbe5a953c78d3e6bb4">00332</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isLoaded(<span class="keywordtype">void</span>)<span class="keyword"> const </span>
<a name="l00333"></a>00333 <span class="keyword">        </span>{ 
<a name="l00334"></a>00334             <span class="comment">// No lock required to read this state since no modify</span>
<a name="l00335"></a>00335             <span class="keywordflow">return</span> (mLoadingState.get() == LOADSTATE_LOADED); 
<a name="l00336"></a>00336         }
<a name="l00337"></a>00337 
<a name="l00341"></a><a class="code" href="classOgre_1_1Resource.html#a23136f099efe86c1134dca0a959ba626">00341</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isLoading()<span class="keyword"> const</span>
<a name="l00342"></a>00342 <span class="keyword">        </span>{
<a name="l00343"></a>00343             <span class="keywordflow">return</span> (mLoadingState.get() == LOADSTATE_LOADING);
<a name="l00344"></a>00344         }
<a name="l00345"></a>00345 
<a name="l00348"></a><a class="code" href="classOgre_1_1Resource.html#a76029b0c460f49dc544015d69befe091">00348</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Resource.html#a07e619aa09d3bc6789a6667cb4fc572c" title="Enum identifying the loading state of the resource.">LoadingState</a> getLoadingState()<span class="keyword"> const</span>
<a name="l00349"></a>00349 <span class="keyword">        </span>{
<a name="l00350"></a>00350             <span class="keywordflow">return</span> mLoadingState.get();
<a name="l00351"></a>00351         }
<a name="l00352"></a>00352 
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 
<a name="l00365"></a><a class="code" href="classOgre_1_1Resource.html#ae20969c8754d9c939b4d88b4a9eefd08">00365</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Resource.html#ae20969c8754d9c939b4d88b4a9eefd08" title="Returns whether this Resource has been earmarked for background loading.">isBackgroundLoaded</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIsBackgroundLoaded; }
<a name="l00366"></a>00366 
<a name="l00375"></a><a class="code" href="classOgre_1_1Resource.html#ae0a0007de944eb3c2f933a372a752b35">00375</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Resource.html#ae0a0007de944eb3c2f933a372a752b35" title="Tells the resource whether it is background loaded or not.">setBackgroundLoaded</a>(<span class="keywordtype">bool</span> bl) { mIsBackgroundLoaded = bl; }
<a name="l00376"></a>00376 
<a name="l00386"></a>00386         <span class="keyword">virtual</span> <span class="keywordtype">void</span> escalateLoading();
<a name="l00387"></a>00387 
<a name="l00391"></a>00391         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addListener(Listener* lis);
<a name="l00392"></a>00392 
<a name="l00396"></a>00396         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeListener(Listener* lis);
<a name="l00397"></a>00397 
<a name="l00399"></a><a class="code" href="classOgre_1_1Resource.html#ae712b3ff458ccbf8e1ff1e33d695bf60">00399</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1Resource.html#ae712b3ff458ccbf8e1ff1e33d695bf60" title="Gets the group which this resource is a member of.">getGroup</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mGroup; }
<a name="l00400"></a>00400 
<a name="l00408"></a>00408         <span class="keyword">virtual</span> <span class="keywordtype">void</span> changeGroupOwnership(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; newGroup);
<a name="l00409"></a>00409 
<a name="l00411"></a><a class="code" href="classOgre_1_1Resource.html#a741224f735dfd9ce324a4e8e621d868c">00411</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* <a class="code" href="classOgre_1_1Resource.html#a741224f735dfd9ce324a4e8e621d868c" title="Gets the manager which created this resource.">getCreator</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mCreator; }
<a name="l00418"></a><a class="code" href="classOgre_1_1Resource.html#a8e4b0066ed588a49cdf474e9870bfcb4">00418</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1Resource.html#a8e4b0066ed588a49cdf474e9870bfcb4" title="Get the origin of this resource, e.g.">getOrigin</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mOrigin; }
<a name="l00420"></a><a class="code" href="classOgre_1_1Resource.html#a3d111616339484f39c9456eeec6fd843">00420</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Resource.html#a3d111616339484f39c9456eeec6fd843" title="Notify this resource of it&#39;s origin.">_notifyOrigin</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; origin) { mOrigin = origin; }
<a name="l00421"></a>00421 
<a name="l00429"></a><a class="code" href="classOgre_1_1Resource.html#a9fef5e371f8e94141624a151ac12e695">00429</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Resource.html#a9fef5e371f8e94141624a151ac12e695" title="Returns the number of times this resource has changed state, which generally means the number of time...">getStateCount</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mStateCount; }
<a name="l00430"></a>00430 
<a name="l00436"></a>00436         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _dirtyState();
<a name="l00437"></a>00437 
<a name="l00438"></a>00438 
<a name="l00447"></a>00447         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _fireLoadingComplete(<span class="keywordtype">bool</span> wasBackgroundLoaded);
<a name="l00448"></a>00448 
<a name="l00457"></a>00457         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _firePreparingComplete(<span class="keywordtype">bool</span> wasBackgroundLoaded);
<a name="l00458"></a>00458 
<a name="l00466"></a>00466         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _fireUnloadingComplete(<span class="keywordtype">void</span>);
<a name="l00467"></a>00467 
<a name="l00468"></a>00468 
<a name="l00469"></a>00469     };
<a name="l00470"></a>00470 
<a name="l00489"></a><a class="code" href="group__Resources.html#ga4697cc0c72aef3b488c7e058adf734ed">00489</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html">SharedPtr&lt;Resource&gt;</a> <a class="code" href="group__Resources.html#ga4697cc0c72aef3b488c7e058adf734ed" title="Shared pointer to a Resource.">ResourcePtr</a>;
<a name="l00490"></a>00490 
<a name="l00512"></a><a class="code" href="classOgre_1_1ManualResourceLoader.html">00512</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>
<a name="l00513"></a>00513     {
<a name="l00514"></a>00514     <span class="keyword">public</span>:
<a name="l00515"></a><a class="code" href="classOgre_1_1ManualResourceLoader.html#a52b91457400f54642fd3c9e0182905f5">00515</a>         <a class="code" href="classOgre_1_1ManualResourceLoader.html#a52b91457400f54642fd3c9e0182905f5">ManualResourceLoader</a>() {}
<a name="l00516"></a><a class="code" href="classOgre_1_1ManualResourceLoader.html#a64c9f1f9f2817de97321412c59fabb5a">00516</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ManualResourceLoader.html#a64c9f1f9f2817de97321412c59fabb5a">~ManualResourceLoader</a>() {}
<a name="l00517"></a>00517 
<a name="l00524"></a><a class="code" href="classOgre_1_1ManualResourceLoader.html#a7b4afd007622d165efbcc362e5566922">00524</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> prepareResource(<a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>* resource)
<a name="l00525"></a>00525                 { (void)resource; }
<a name="l00526"></a>00526 
<a name="l00530"></a>00530         <span class="keyword">virtual</span> <span class="keywordtype">void</span> loadResource(<a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>* resource) = 0;
<a name="l00531"></a>00531     };
<a name="l00534"></a>00534 }
<a name="l00535"></a>00535 
<a name="l00536"></a>00536 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
